from gensim import models

# Hard-wired path, easy to replace with ArgumentParser
sotu = "sotu_sent_per_line.txt"

with open(sotu, encoding="utf8") as f:
	plain_text = f.read()

sentences = plain_text.split("\n")
tokenized = []

for sentence in sentences:
	tokens = sentence.strip().lower().split(" ")
	tokenized.append(tokens)

model = models.Word2Vec(tokenized, min_count=3, size=50, seed=42)

# This is how to load a pre-trained model -
# You'll need to download a large file,
# 1.5GB, use with caution
#google_news = "GoogleNews-vectors-negative300.bin.gz"
#model = models.Word2Vec.load_word2vec_format(google_news, binary=True)
#google_news_mini = "GoogleNewsVecs.txt"
#model = models.KeyedVectors.load_word2vec_format(google_news_mini)

# Is 'america' more similar to 'country' or 'goal'?
print(model.wv.similarity('america', 'country') > model.wv.similarity('america','goal'))
#-- True

# Let's find the most similar words to 'america'
print(model.wv.most_similar(positive=['america','continent'],negative=["government","country"],topn=3))
# Or crisis:
print(model.wv.most_similar(positive=['crisis'],topn=3))


# What's a leader/king like?
print(model.wv.most_similar(positive=['leader','king'],topn=1))
# What if we're looking for words more distant from king? Can we pull it towards 'American'?
print(model.wv.most_similar(positive=['american','leader'], negative=['king'],topn=1))


# Spot the odd one out
print(model.wv.doesnt_match(["france","germany","car","japan"]))
